                .model  tiny
                .code
                locals
                .radix  16
PUBLIC          RND_INIT, RND_GET, RND_GET_THREE_BITS, RND_GET_BYTE

;
RND_INIT        proc
                mov     ah,2C                   ; get time
                int     21
                mov     ax,3E1
                mul     dx
                add     ax,cx
                xchg    cx,ax
                in      ax,40                   ; timer port
                add     ax,cx
                mov     word ptr [rng_buffer],ax
                retn
RND_INIT        endp
;


;
RND_GET_BYTE    proc
                call    RND_GET
                xor     ah,ah
                ret
RND_GET_BYTE    endp
;


;
RND_GET_THREE_BITS      proc
                        call    RND_GET_BYTE
                        and     al,00000111b
                        ret
RND_GET_THREE_BITS      endp
;


;
RND_GET         proc
                push    bx cx dx
rng_buffer      = $+1
                mov     ax,1111
                mov     cx,3E1
                mul     cx
                mov     cx,ax
                xor     dx,dx
                mov     bx,35
                div     bx
                add     dx,cx
                js      @@1
                in      ax,40                   ; port 40, 8253 timer 0 clock
                add     dx,ax
@@1:
                cmp     dx,word ptr [rng_buffer]
                jne     @@2
                neg     dx
                in      ax,40                   ; port 40, 8253 timer 0 clock
                xor     dx,ax
@@2:
                mov     word ptr [rng_buffer],dx
                xchg    dx,ax
                pop     dx cx bx
                retn
RND_GET         endp
;
end