                warn
                jumps
                locals
                .model  tiny
                .code
                .radix  16
include ZME.asi
                org     100
;



ZME_demo:      jmp     enter_ZME_demo
newsize         dw ?

prompt          db      PRODUCTNAME,'  Generation Difference Demonstration',0Dh,0A
                db      0A,9,'   (C) The Black Baron 1995',0Dh,0A,0A,0A
                db      'SELECT THE NUMBER OF GENERATIONS:',0Dh,0A,0A
                db      '1  --      3      Generations',0Dh,0A
                db      '2  --     30',0Dh,0A
                db      '3  --    300',0Dh,0A
                db      '4  --  3.000$'

_10             db      ' 3 $'
_100            db      ' 30 $'
_1000           db      ' 300 $'
_10000          db      ' 3000 $'

generating      db      0Dh,0A,0A,0A,'Generating$'


please_wait     db      'Executable .COM Generations, Please Wait...$',0Dh,0A

checkdiff       db      0Dh,0A,0A
                db      'DONE!  Now examine each, and'
                db      ' note how different they are!',0Dh,0A,0A,'$'

diskerror       db      0Dh,0A,0A,'SORRY!  A disk error has occurred!'
                db      0Dh,0A,0A,7,'$'

num2gen         dw      3d, offset _10
                dw      30d, offset _100
                dw      300d, offset _1000
                dw      3000d, offset _10000

enter_ZME_demo:
                ;mov     ax,3                   ; set video mode to standard
                ;int     10                     ; text mode (clear screen, too)
                                                ;
                mov     dx,offset prompt        ; display prompt
                mov     ah,9                    ;
                int     21                      ;
                                                ;
inputloop:      mov     ax,0C07                 ; clear keyboard buffer & get
                int     21                      ; keystroke
                                                ;
                cmp     al,'1'                  ; must be between 1 and 4
                jb      inputloop               ;
                cmp     al,'4'                  ;
                ja      inputloop               ;
                                                ;
                sub     al,'1'                  ; normalise
                xor     ah,ah                   ; and find out how many files
                add     ax,ax                   ; we should generate
                add     ax,ax                   ;
                add     ax,offset num2gen       ;
                xchg    bx,ax                   ;
                push    bx                      ;
                                                ;
                mov     dx,offset generating    ;
                mov     ah,9                    ; display string
                int     21                      ;
                                                ;
                pop     bx                      ; display num to generate
                mov     cx,[bx]                 ;
                push    cx                      ;
                mov     dx,[bx+2]               ;
                int     21                      ;
                                                ;
                mov     dx,offset please_wait   ; display string again
                int     21                      ;
                                                ;
                pop     cx                      ;
                                                ;
gen_file_loop:  push    cx                      ;
                mov     bp,offset ZME_END      ; set up ZME registers
                mov     di,offset ZME_END+ENGINEDATASIZE
                mov     dx,offset carrier       ;
                mov     cx,offset end_carrier - offset carrier
                mov     ax,100                  ; COM files start exec @ 100
                call    ZME                    ; encrypt the carrier file
                 mov     [newsize],ax
                                               ;
                mov     ah,5Bh                  ; create new file
                mov     dx,offset filename      ;
                xor     cx,cx                   ;
                int     21                      ;
                jnc     created_file            ;
print_error_exit:                               ;
                call    print_error             ;
exit_error:     pop     cx                      ;
                mov     ax,4CFF                 ; terminate errorlevel -1
                int     21                      ;
                                                ;
created_file:   xchg    bx,ax                   ;
                jmp     write_rest              ;
                                                ;
close_exit:     call    print_error             ;
                mov     ah,3E                   ; close file
                int     21                      ;
                jmp     short exit_error        ;
                                                ;
write_rest:
                mov     ah,40                   ; write decryptor
                mov     cx,[newsize]
                mov     dx,offset ZME_END+ENGINEDATASIZE
                int     21                      ;
                jc      close_exit              ;
                                                ;
                                                ;
                mov     ah,3E                   ; close file
                int     21                      ;
                jc      print_error_exit        ;
                                                ;
                mov     bx,offset filename+7    ; calculate next file name
                mov     cx,4                    ;
inc_fname:      inc     byte ptr [bx]           ;
                cmp     byte ptr [bx],3A        ;
                jb      increment_done          ;
                sub     byte ptr [bx],0A        ;
                dec     bx                      ;
                loop    inc_fname               ;



increment_done: pop     cx                      ;
                loop    gen_file_loop           ;
                                                ;
                mov     dx,offset checkdiff     ; display string
                mov     ah,9                    ;
                int     21                      ;
                                                ;
                mov     ax,4C00                 ; exit errorlevel 0
                int     21                      ;
                                                ;
print_error:    mov     dx,offset diskerror     ; display error message
                mov     ah,9                    ;
                int     21                      ;
                retn                            ;
;
;
;
;
carrier:        call    enter_carrier           ;
 filename        db      'shit0000.COM', 0
                 db      '  This was decrypted with a ',PRODUCTNAME,' generated'
                db      ' decryptor!',0Dh,0A,'$';
enter_carrier:  pop     dx                      ;
                db      0802 dup (90h)
                mov     ah,9                    ; print string
                int     21                      ;
                                                ;
                mov     ax,4c00                 ; terminate
                int     21                      ;
end_carrier:                                    ;
;
;
;
;
end   ZME_demo